/* lab8a.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>

#define I_MAX_THREADS   254
#define SZ_FORMATO      "Formato: p <#threads>\n"
#define SZ_MAX_THREADS  "O maximo de threads permitido e' %d\n"
#define SZ_ERRO_CRIA    "Erro na criacao do thread %d\n"
#define SZ_NUM_THREADS  "Numero de threads %d\n"
#define SZ_CHA_DORME    "Processo %d chamando sleep\n"
#define SZ_CHA_ACORDA   "Processo %d chamando wakeup\n"
#define SZ_ACORDANDO    "Processo %d acordou\n"


int   iNumThreads     ,
      iEsperando  = 0 ;
sem_t SemExcMut       ,
      SemDormida      ;


void* Dormir( void* MeuId ) ;

void* Acordar( void* MeuId ) ; 

void sleep( void ) ;

void wakeup( void ) ;

void Esperar( int iMeuId ) ;

void Sinalizar( void ) ;


void* Dormir( void* MeuId ) {
   int iMeuId = *( int* )MeuId ;   

   while ( 1 ) {
      printf( SZ_CHA_DORME, iMeuId ) ;
      sleep( ) ;
      printf( SZ_ACORDANDO, iMeuId ) ;
      Esperar( iMeuId ) ;
   } /* while */
} /* Dormir */


void* Acordar( void* MeuId ) {
   int iMeuId = *( int* )MeuId ;   

   while ( 1 ) {
      printf( SZ_CHA_ACORDA, iMeuId ) ;
      wakeup( ) ;
      Esperar( iMeuId ) ;
   } /* while */
} /* Acordar */


void sleep( void ) {
   sem_wait( &SemExcMut ) ;
   iEsperando++ ;
   sem_post( &SemExcMut ) ;
   sem_wait( &SemDormida ) ;
   iEsperando-- ;
   Sinalizar( ) ;
} /* sleep */


void wakeup( void ) {
   sem_wait( &SemExcMut ) ;
   Sinalizar( ) ;
} /* wakeup */


void Sinalizar( void ) {
   if ( iEsperando > 0 ) {
      sem_post( &SemDormida ) ;
   } else { 
      sem_post( &SemExcMut ) ;
   } /* if */
} /* Sinalizar */


void Esperar( int iMeuId ) {
   unsigned long int i                                        ,
                     lTotal = ( unsigned long )10000000L 
                            * ( unsigned long )( iMeuId + 1 ) ;

   for ( i = 0 ; i < lTotal ; i++ ) { }
} /* Esperar */


int main( int   argc    ,
          char* argv[ ]  ) {
   int       i                       ,
             iErro                   ;
   int*      pMeuId                  ;
   pthread_t Thread[ I_MAX_THREADS ] ;

   if ( argc != 2 ) {
      printf( SZ_FORMATO ) ;
      return 0 ;
   } /* if */

   iNumThreads = atoi( argv[ 1 ] ) ;

   if ( iNumThreads > I_MAX_THREADS ) {
      printf( SZ_MAX_THREADS, I_MAX_THREADS ) ;
      return 0 ;
   } /* if */

   printf( SZ_NUM_THREADS, iNumThreads ) ;

   sem_init( &SemExcMut, 0, 1 ) ;
   sem_init( &SemDormida, 0, 0 ) ;

   for ( i = 0 ; i < iNumThreads ; i++ ) {
      pMeuId = ( int* )malloc( sizeof( int ) ) ;
      *pMeuId = i ;

      iErro = pthread_create( &Thread[ i ], NULL, Dormir,
                                                  ( void* )( pMeuId ) ) ;

      if ( iErro != 0 ) {
         printf( SZ_ERRO_CRIA, i ) ;
         return 1 ;
      } /* if */
   } /* for */

   Acordar( ( void* )&i ) ;
   return 0 ;
}
